#ifndef COLLI_H
#define COLLI_H

#define STACKSIZE 20

#define ERR_INVALID_PARAMETER 	-100
#define ERR_STACK_FULL 			-200
#define ERR_NOT_INITIALIZED 	-300
#define ERR_BAD_EXPRESSION		-400
#define ERR_EMPTY_STACK			-500

enum StackDefs {
	COMMAND,
	VALUE,
	SHAPE,
	ID,
	BIND,
	ROTATE,
	TRANSLATE,
	SCALE,
	SHOW,
	VISUALIZE
};

typedef struct ColliStack_{

	int command[STACKSIZE];
	char *parameters[STACKSIZE];
	int type[STACKSIZE];
	int size;

} ColliStack;

int child;

ColliStack *colliInit();

int colliPushId(ColliStack *stack, char *id);
int colliPushCommand(ColliStack *stack, int command);

int colliPushValue(ColliStack *stack, double value);
int colliPushShape(ColliStack *stack, char *shape);

int colliPop(ColliStack *stack);

int colliPrintStack(ColliStack *stack);

char **colliTest(char *id, int *totalCollisions);
int colliRun(ColliStack *s);

int colliClose(ColliStack *stack);

#endif
