#include <stdio.h>
#include <stdlib.h>

#include "colli.h"

int main(){

	int i = 0;
	char **results;
	int totalCollisions = 0;

	ColliStack *s = colliInit();

	colliPushId(s, "first");
	colliPushShape(s, "circle");
	colliPushCommand(s, BIND);
	
	colliRun(s);
		
	colliPushId(s, "first");
	colliPushValue(s, 100);
	colliPushCommand(s, SCALE);
	colliRun(s);
	
	colliPushId(s, "first");
	colliPushValue(s, 300.0);
	colliPushValue(s, 300.0);
	colliPushCommand(s, TRANSLATE);
	colliRun(s);

	colliPushId(s, "first");
	colliPushCommand(s, SHOW);
	colliRun(s);

	colliPushId(s, "second");
	colliPushShape(s, "square");
	colliPushCommand(s, BIND);
	colliRun(s);

	colliPushId(s, "second");
	colliPushValue(s, 150);
	colliPushCommand(s, SCALE);
	colliRun(s);

	colliPushId(s, "second");
	colliPushValue(s, 300.0);
	colliPushValue(s, 400.0);
	colliPushCommand(s, TRANSLATE);
	colliRun(s);

	colliPushId(s, "second");
	colliPushCommand(s, SHOW);
	colliRun(s);
	
	colliPushCommand(s, VISUALIZE);
	colliRun(s);

	results = colliTest("first", &totalCollisions);
	
	if(results){
		for(i = 0; i < totalCollisions; i++)
			printf("first collided with %s\n", results[i]);
	}
	else
		puts("NULL results!");

	colliClose(s);
	
	return 0;
}
