%{
#ifndef PRINT
	#define TOKEN(s) return(s);
#else
	#define TOKEN(s) printf("Lexeme: %s \n -> Token returned: %s\n\n", yytext, #s);
#endif

extern YYSTYPE yylval;
extern SymbolTable symbolTable[SYMTABSIZE];
int currentTableSize = 0;

#include <stdio.h>
%}

%option yylineno
%option yywrap
%option always-interactive

/*Definitions*/

delim       	[ \t]

ws          	{delim}+

eol				[.\n]

character      	[A-Za-z]
digit       	[0-9]

identifier		{character}({character}|{digit})*
number			("+"|"-")?{digit}+"."{digit}+

character_constant	"'"{character}"'"
 
%%
{ws}        		; /* white space, do nothing */

is					TOKEN(IS)

"bound by"			TOKEN(BOUNDBY)
scaled				TOKEN(SCALED)
translated			TOKEN(TRANSLATED)
rotated				TOKEN(ROTATED)

"collisions with"	TOKEN(COLLISIONTEST)

"show"				TOKEN(SHOW)
"scene"				TOKEN(SCENE)

square				TOKEN(SQUARE)
circle				TOKEN(CIRCLE)

reference			TOKEN(REFERENCE)

all					TOKEN(ALL)

"\n"				TOKEN(EOL)

"quit"				TOKEN(QUIT)
		
{identifier}			{
//							printf("Adding %s to the table...\n", yytext);

							yylval.iVal = installId(yytext);
							TOKEN(IDENTIFIER)
						}
												
{number}				{
							yylval.dVal = atof(yytext);
							TOKEN(NUMBER)
						}

"{"						TOKEN(BRA)
"}"						TOKEN(KET)

";"						TOKEN(LISTSEPARATOR)
","						TOKEN(VARSEPARATOR)

%%
