#ifndef DOUBLEVECTOR_H
#define DOUBLEVECTOR_H

#define INVALID_VECTOR -1
#define INVALID_INDEX -2
#define VECTOR_FULL -3

typedef struct doubleVector_{

	int self;
	double* vectorElems;
	
	//Geometric center coordinates
	double centerX;
	double centerY;
	
	int size;
	int capacity;
	int type;	
} doubleVector;

doubleVector* createDoubleVector(int nElems);

int destroyDoubleVector();

int pushDoubleBack(doubleVector* vector, double elem);

int popDoubleByIndex(doubleVector* Vector, int elem);

int printDoubleVector(const doubleVector* vector);

int sortDoubleVector(doubleVector* Vector);

#endif
