#ifndef TREE_FUNCTIONS_H
#define TREE_FUNCTIONS

#define OPTION_TYPE(node) node->first->nodeType

#include "parserDefs.h"
#include "doubleVector.h"
#include "symbolTable.h"
#include "collision.h"

typedef struct ternaryTreeNode_{

    int  iVal;
    double dVal;
    
    int  nodeType;
    
	struct ternaryTreeNode_* first;
    struct ternaryTreeNode_* second;
    struct ternaryTreeNode_* third;
} ternaryTreeNode;

ternaryTreeNode* createNode(int, double, int, ternaryTreeNode*, ternaryTreeNode*, ternaryTreeNode*);

void printTree(ternaryTreeNode* node, int indentLevel);
void run(ternaryTreeNode* node);

int getIndex(doubleVector** objectList, int listSize, int id);
doubleVector* getById(doubleVector** objectList, int currentObjects, int id);

int makeTranslation(doubleVector* object, double xOffset, double yOffset);
int makeScaling(doubleVector* object, double ratio);
int makeRotation(doubleVector* object, double angle);

int applyOption(doubleVector *object, const ternaryTreeNode* option);

int checkSize(ternaryTreeNode *list, char reset);
int fillObject(doubleVector *object, const ternaryTreeNode *list);

void cleanUp();

#define PI 3.14159265

#define CIRCLE_SHAPE	100
#define SQUARE_SHAPE	200
#define ALL_QUERY		300
#define REF				400

#define CONVEX_SHAPE	500
#define CONCAVE_SHAPE	600

//const char* getByNumber(int n);
//void writeFormat(TERNARY_TREE t);
//char check(int index, int nodeID);

#endif
