#include <stdio.h>
#include <stdlib.h>

#include "doubleVector.h"

doubleVector* createDoubleVector(int nElems){

	doubleVector* vector = (doubleVector *)malloc(sizeof(doubleVector));

	if(!vector)
		return NULL;

	vector->vectorElems = (double *)malloc(nElems*sizeof(double));
	
	if(!vector)
		return NULL;

	vector->size = 0;
	vector->capacity = nElems;

	return vector;
}

int destroyDoubleVector(){

	return 0;
}

int pushDoubleBack(doubleVector* vector, const double elem){

	if(!vector)
		return INVALID_VECTOR;

	if(vector->size == vector->capacity)
		return VECTOR_FULL;

	vector->vectorElems[vector->size] = elem;	
	vector->size++; 

	return 0;
}

int printDoubleVector(const doubleVector* vector){

	int i = 0;

	if(!vector)
		return INVALID_VECTOR;
		
	for(i = 0; i < vector->size; i++){
		printf("%.2f", vector->vectorElems[i]);

		if(i == vector->size - 1)
			printf(" ");
		else if(i % 2 == 1 && i != 0)
			printf(" ; ");
		else
			printf(", ");
		
	}
/*	printf("\n");*/
	
	return 0;
}

