#include <string.h>
#include <stdlib.h>
#include <stdio.h>

#include "symbolTable.h"

extern int currentTableSize;
int numAssigned = 0;

int printTable(SymbolTable* table){

	int i = 0;

	if(!table)
		return -1;

	for(i = 0; i < currentTableSize; i++)
		printf("%s ", table[i].identifier);

	printf("\n");
	
	return 0;
}

int installId(char *id) {
	/*
	Look up an identifier in the symbol table, if it is there return
	its index.  If it is not there, push it to the end
	as long as the table isn't full, and return its index.
	*/

    int index = lookupId(id); //Looks up the id so that duplicates won't be added to the table
    
    if (index >= 0)
        return (index);
    
    else {
       symbolTable[currentTableSize].identifier = (char *)malloc(sizeof(char)*IDLENGTH);
       
       strcpy(symbolTable[currentTableSize].identifier,id);
       
       return currentTableSize++;
    }
}

int lookupId(char *id)
{
	//Searches for an Identifier by name, returning it's index if found.

	int i = 0;

    for(i = 0; i < currentTableSize; i++)
        if(strcmp(id, symbolTable[i].identifier) == 0)
            return i;
    
    return NOT_FOUND;    
}

void initTables(){

	memset(assignedVariables, -1, SYMTABSIZE*sizeof(int));

	return;
}

char assign(int id){

	if(numAssigned < SYMTABSIZE){
		assignedVariables[numAssigned] = id;
		numAssigned++;	
	}
	
	return 0;
}

char isAssigned(int index){

	//checks if an id is was assigned by one of the allowed statements.
	int i;
	
	for(i = numAssigned - 1; i >= 0; i--){
		if(assignedVariables[i] == index){
/*			printf("Assigned!\n");*/
			return TRUE;
		}
	}

/*	printf("Not Assigned!\n");*/
	return FALSE;
}

