#include "vectorMath.h"

#include <stdlib.h>

//All functions implemented for 2D vectors

double norm(double *v){

	if(!v)
		return 0.0;

	return sqrt(v[0]*v[0] +v[1]*v[1]);

}

double* scalarMult(double scalar, const double *vector){

	double *result = (double *)malloc(2*sizeof(double));

	result[0] = scalar*vector[0];
	result[1] = scalar*vector[1];
	
	return result;	
}

double dotProduct(double *a, double *b){

	return a[0]*b[0] + a[1]*b[1];

}

double* vectorSum(double *a, double *b){

	double *result = (double *)malloc(2*sizeof(double));

	result[0] = a[0] + b[0];
	result[1] = a[1] + b[1];
	
	return result;
}

double* vectorSub(double *a, double *b){

	double *result = (double *)malloc(2*sizeof(double));

	result[0] = a[0] - b[0];
	result[1] = a[1] - b[1];
	
	return result;
}

double* rotate(const double *vector, double theta){

	double cos_t = cos(theta);
	double sin_t = sin(theta);

	double *result = (double *)malloc(2*sizeof(double));

	result[0] = vector[0] * cos_t - vector[1] * sin_t;
	result[1] = vector[0] * sin_t + vector[1] * cos_t;
	
	return result;
}
